#!/bin/bash

# -------------------------------------------------------------------------- #
# Copyright 2002-2009, Distributed Systems Architecture Group, Universidad   #
# Complutense de Madrid (dsa-research.org)                                   #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

SRC=$1
DST=$2

if [ $# -gt 2 ]; then
    SIZE=$3
fi

if [ -z "${ONE_LOCATION}" ]; then
    TMCOMMON=/usr/lib/one/mads/tm_common.sh
else
    TMCOMMON=$ONE_LOCATION/lib/mads/tm_common.sh
fi

. $TMCOMMON

SRC_PATH=`arg_path $SRC`
DST_PATH=`arg_path $DST`

SRC_HOST=`arg_host $SRC`
DST_HOST=`arg_host $DST`

if [ $# -gt 2 ]; then
    log "$1 $2 $3"
else
    log "$1 $2"
fi

log "DST: $DST_PATH"

DST_DIR=`dirname $DST_PATH`

log "Creating directory $DST_DIR"
exec_and_log "ssh $DST_HOST mkdir -p $DST_DIR"

case $SRC_PATH in
#http://*)
#    log "Downloading $SRC"
#    exec_and_log "ssh $DST_HOST wget -O $DST_PATH $SRC_PATH"
#    ;;
#
/dev/*)
    log "Cloning LVM $LVSRC"
    # Default to 1G clone size
    if [ $# -lt 3 ]; then
        SIZE="1G"
    fi
    #Combine VID number and disk number into LV name
    LV_PATH=`echo $DST_PATH|awk -F "/" '{print "vid-" $(NF-2) "." $(NF)}'`
    exec_and_log "ssh $DST_HOST sudo /usr/sbin/lvcreate -s -L$SIZE -n $LV_PATH $SRC_PATH"
    ;;

*)
    log "Cloning $SRC"
    exec_and_log "ssh $DST_HOST cp $SRC_PATH $DST_PATH"
    exec_and_log "ssh $DST_HOST chmod a+w $DST_PATH"
    ;;
esac
